library(survival)
library(splines)

wl.id<-pmatch(rownames(wl),rownames(wl.data.mi))
head(wl.id)
identical(rownames(wl),rownames(wl.data.mi)[wl.id])
head(wl.data.mi[-wl.id,])

wl.mi<-wl ########same as "Waitinglist_MI_AGE.csv"
dim(wl)
head(wl)
rownames(wl)
table(wl$txp)


#wl.mi<-read.csv("D:/Fei/umich2013/kecc/WaitListing/Feb2015/Waitinglist_MI.csv")
#head(wl.mi)
#names(wl.mi)

replace.ti = function(t_i){
  ti = ifelse(is.na(t_i), 99999, t_i)
  return(ti)
}

ti = apply(as.matrix(wl.mi$txp_time), 1, 'replace.ti')
y = wl.mi$surv_time
status = wl.mi$died
sum(status)

Z0<-wl.mi$CAN_AGE_IN_MONTHS_AT_LISTING/12
Z1 = wl.mi$can_bmi_0c 
table(wl.mi$CAN_GENDER)
Z2 = as.numeric(wl.mi$CAN_GENDER=="F")

table(wl.mi$can_malig_0cc)
wl.mi$can_malig_Y<-(wl.mi$can_malig_0cc=="Y")
table(wl.mi$can_malig_Y)
Z3 = as.numeric(wl.mi$can_malig_Y)
Z4 = wl.mi$can_max_cold_tm_0c

table(wl.mi$can_diab_comb)
wl.mi$can_diab_1<-(wl.mi$can_diab_comb==1)
Z5 = as.numeric(wl.mi$can_diab_1)
Z<-cbind(Z0,Z1,Z2,Z3,Z4,Z5)
head(Z)
dim(Z)

alpha<-coef(cox1)[-1]
#> alpha
##ZZ0         ZZ1         ZZ2         ZZ3         ZZ4         ZZ5 
##0.01908135 -0.03777126 -0.07663129  0.43655890  0.01422014  0.47645035 
fit2<-GPLE_adp_resample(Z,ti,y,status,alpha,initial,0.15,0.02)

fit1<-GPLE_adp(Z,ti,y,status,alpha,initial,0.15,0.02)
class(fit1)
fit1[[4]]
plot(fit1[[1]],fit1[[3]])
plot(fit1[[1]],fit1[[5]])

smooth<-loess(fit1[[3]]~fit1[[1]], span = 0.1, degree = 2)
plot(fit1[[1]],fit1[[3]])
plot(1,xlim=c(0,1600),ylim=c(-3,1))
abline(h=0)
lines(smooth)
?loess
predict(smooth,1000)

ss1<-smooth.spline(fit1[[1]],fit1[[3]],df=20)
lines(ss1)
save.image("fitMI.RData")

####################get initial beta
Timeafttxp<-wl.mi$surv_time-wl.mi$txp_time
hist(Timeafttxp,main='Time after Transplant for Michigan')
#bs1<-bs(Timeafttxp,intercept=TRUE)
bs2<-bs(Timeafttxp,knots=10)
bs2[is.na(bs2)]<-0
cox2<-coxph(Surv(surv_time,died)~as.matrix(wl[,-(1:3)])+bs2,data=wl.mi)
summary(cox2)
coefb<-cox2$coefficients[6:9]
initialb<-bs2%*%coefb
initialalpha<-cox2$coefficients[1:5]
plot(Timeafttxp,initialb)

smoothb<-loess(initialb~Timeafttxp, span = 1/10, degree = 2)
ini_b<-predict(smoothb,T0)
#ini_b<-predict(smooth,T0)
plot(T0,ini_b)

n0<-length(y)
time<-sort(unique(y[status==1]))
d<-length(time)
M1<-outer(ti,rep(1,d))<=outer(rep(1,n0),time)
timeTT<- -outer(ti,rep(1,d))+outer(rep(1,n0),time)
T0<-unique(round(unique(sort(abs(c(timeTT[abs(timeTT)<9999])))),2))
initial<- outer(rep(0,n0),time)
for(i in 1:ncol(timeTT)){
  initial[,i]<-predict(smooth,timeTT[,i])
}
initial[is.na(initial)]<-0
dim(initial)
